import matplotlib.pyplot as plt
import numpy as np
####
# Note that all Bayes factors here are input by hand. The related json files are LHO" /home/eungwang.seo/public_html/Injection_test.
# After finishing this injection study, congregate all results in one directory.
# From csv file, I used 0~20, 100~130 and 156~200 injections.
####

B_F= np.loadtxt('App_D_Fig_6.dat')

# ln Bayes factor for unlensed injections recovered by lensed template.
UGLT = B_F[0] 

# ln Bayes factor for unlensed injections recovered by unlensed template.Namely, normal PE.
UGUT = B_F[1]

# Convert lists to arrays for calculating log_10_Bayes factors.
UGUT = np.array(UGUT)
UGLT = np.array(UGLT)

# log_10_Bayes_factor between lensed hypothesis and unlensed hypothesis
a = (UGLT - UGUT)/np.log(10)

# The number of injections
print(len(a))

# Minimum and maximum value of the group of bayes factors.
print(min(a),max(a))

# Sorted the arrays (Unlensed injections)
UG_bayes = sorted(a)

# Make the histogram of distribution of log_10_Bayes factor.
#plt.figure(figsize=[20,10])
#plt.title('Injection run test',fontsize=45,pad=20)
ff = np.zeros(16)
for i in UG_bayes:
    if -3.0 <= i <-2.75:
        ff[0] += 1
    elif -2.75 <= i <-2.50:
        ff[1] += 1
    elif -2.50 <= i <-2.25:
        ff[2] += 1
    elif -2.25 <= i <-2.00:
        ff[3] += 1
    elif -2.00 <= i <-1.75:
        ff[4] += 1
    elif -1.75 <= i < -1.50:
        ff[5] += 1
    elif -1.50 <= i <-1.25:
        ff[6] += 1
    elif -1.25 <= i < -1.00:
        ff[7] += 1
    elif -1.00 <= i < -0.75:
        ff[8] += 1
    elif -0.75 <= i < -0.50:
        ff[9] += 1
    elif -0.50 <= i < -0.25:
        ff[10] += 1
    elif -0.25 <= i < 0.00:
        ff[11] += 1
    elif 0.00 <= i < 0.25:
        ff[12] += 1
    elif 0.25 <= i < 0.50:
        ff[13] += 1
    elif 0.50 <= i < 0.75:
        ff[14] += 1
    elif 0.75 <= i < 1.00:
        ff[15] += 1

ran = np.arange(-3.0,1.00,0.25)
plt.bar(ran,ff,color='blue',alpha = 0.5,width=0.25,align='edge')
plt.axhline(0.0, color='black', lw=0.5)
plt.ylabel(r"Number of events")
plt.xlabel(r"$\log_{\mathrm{10}} \mathcal{B}_{\rm U}^{\rm ML}$")
#plt.xticks(np.arange(-3.0,1.25,0.25),fontsize=22)
#plt.yticks()
#plt.tick_params(length=10,width=1.5,direction='in',axis='y')
#plt.legend()
plt.savefig('App_D_Fig_6.pdf', bbox_inches='tight')
